<script>
import { onUpdated, toRaw } from 'vue';
import DuoChatMessage from './components/chat_message.vue';
import PaperAirplaneIcon from './components/icons/PaperAirplaneIcon.vue';

const vscode = acquireVsCodeApi();

export default {
  name: 'GitLabDuoChat',
  components: {
    DuoChatMessage,
    PaperAirplaneIcon,
  },
  data() {
    return {
      chatMessages: [],
      promptDraft: null,
    };
  },
  created() {
    window.vsCodeApi = vscode;
    window.addEventListener('message', this.handleExtensionMessageEvent);
    window.vsCodeApi.postMessage({ command: 'appReady' });
  },
  onBeforeDestroy() {
    window.removeEventListener('message', this.handleExtensionMessageEvent);
  },
  mounted() {
    this.attachToVsCodeState();
  },
  methods: {
    handleExtensionMessageEvent(event) {
      const message = event.data;
      console.log('received', message);

      switch (message.eventType) {
        case 'focus': {
          this.focusInput();
          break;
        }
        case 'newRecord': {
          this.newRecord(message.record);
          break;
        }
        case 'updateRecord': {
          this.updateRecord(message.record);
          break;
        }
        default:
          console.log('Chat view received unexpected message type.');
          break;
      }
    },
    newRecord(record) {
      this.chatMessages.push(record);
      this.scrollBottom();
    },
    updateRecord(record) {
      const index = this.chatMessages.findIndex(r => r.id === record.id);

      this.chatMessages[index] = record;

      this.scrollBottom();
    },
    scrollBottom() {
      setTimeout(() => {
        window.scrollTo(0, document.body.scrollHeight);
      }, 20); // TODO: replace this hack with proper CSS.
    },
    attachToVsCodeState() {
      onUpdated(() => {
        window.vsCodeApi.setState({
          promptDraft: toRaw(this.promptDraft),
        });
      });

      const currentState = window.vsCodeApi.getState();
      if (currentState && currentState.promptDraft) {
        this.promptDraft = currentState.promptDraft;
      }
    },
    // form related stuff.
    submitPrompt() {
      window.vsCodeApi.postMessage({
        eventType: 'newPrompt',
        record: {
          content: this.promptDraft,
        },
      });
      this.promptDraft = null;
    },
    handleKeyPress(event) {
      if (event.key === 'Enter' && !event.shiftKey) {
        event.preventDefault();
        this.submitPrompt();
      }
    },
    focusInput() {
      this.$refs.promptTextarea.focus();
    },
  },
};
</script>
<template>
  <section>
    <div class="header">Responses generated by AI.</div>
    <div id="chat-history">
      <duo-chat-message v-for="message in chatMessages" :key="message.id" :message="message" />
    </div>
    <footer>
      <form @submit.stop.prevent="submitPrompt">
        <div class="input-group">
          <div class="input">
            <textarea
              rows="1"
              placeholder="Ask a question"
              ref="promptTextarea"
              v-model="promptDraft"
              @keypress="handleKeyPress"
            ></textarea>
          </div>
          <div class="input-group-append">
            <button type="submit">
              <paper-airplane-icon />
            </button>
          </div>
        </div>
        <small>
          May provide inappropriate responses not representative of GitLab's views. Do not input
          personal data.
        </small>
      </form>
    </footer>
  </section>
</template>
<style lang="scss">
:root {
  --font-family: var(--vscode-font-family);
}
* {
  box-sizing: border-box;
}
body {
  padding: 0;
}
section {
  font-family: var(--font-family);
  display: flex;
  flex-direction: column;
  height: 100vh;
}
.header {
  text-align: center;
  width: 100%;
  position: sticky;
  top: 0;
  color: var(--vscode-foreground);
  background: var(--vscode-widget-shadow);
  padding: 0.5rem;
}
#chat-history {
  display: flex;
  flex-direction: column;
  flex-grow: 1;
  padding: 0.5rem;
}
footer {
  position: sticky;
  bottom: 0;
  border-top: 1px solid var(--vscode-widget-border);
  padding: 0.5rem;
  background-color: var(--vscode-sideBar-background);

  .input-group {
    position: relative;
    display: flex;
    flex-wrap: wrap;
    align-items: stretch;
  }

  .input {
    display: inline-grid;
    max-width: 100%;
    min-height: 2.5rem;
    flex-grow: 1;
    box-shadow: inset 0 0 0 1px var(--vscode-settings-textInputBorder);
    background-color: var(--vscode-input-background);
    border-radius: 0.25rem;
  }

  textarea {
    width: calc(100% - 40px);
    max-height: 240px;
    border: none;
    outline: none;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    resize: none;
    height: 100%;
    padding: 0.75rem 0.5rem;
    box-shadow: none;
    border-radius: 0.25rem;
    border-bottom-right-radius: 0;
    border-top-right-radius: 0;
    color: var(--vscode-input-foreground);
    background-color: transparent;
    font-family: var(--font-family);

    &::placeholder {
      color: var(--vscode-disabledForeground);
    }

    &:focus {
      box-shadow: none;
      outline: none;
    }
  }

  .input-group-append {
    display: flex;

    button {
      padding: 0.5rem;
      background-color: var(--vscode-button-background);
      box-shadow: inset 0 0 0 1px var(--vscode-button-border);
      color: var(--vscode-button-foreground);
      cursor: pointer;
      border-width: 0;
      flex-shrink: 0;
      border: none;
      border-radius: 0.25rem;

      position: absolute;
      bottom: 0.25rem;
      right: 0.25rem;

      svg {
        width: 16px;
        height: 16px;
        vertical-align: -3px;
        fill: currentColor;
      }
    }
  }

  form small {
    margin-top: 1rem;
    color: var(--vscode-disabledForeground);
  }
}
</style>
